//--------------------------------------------------------------------------------------------------
//
// Title       : UART
// Design      : serial_invert
// Author      : 
// Company     : 
//
//-------------------------------------------------------------------------------------------------
//
// File        : UART.v
// Generated   : Tue Jan 21 13:49:59 2003
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`timescale 1ps / 1ps




module UART (
	io_recv,
	io_send,
	
	uart_read_enable_i,
	uart_write_enable_i,
	uart_full,
	uart_empty,
	uart_data_in,
	uart_data_out,
	
	uart_baud_clock,
	
	clock,
	reset
	);
	
	input	     io_recv;
	output	     io_send;
	
	input	     uart_read_enable_i;
	input	     uart_write_enable_i;
	output	     uart_full;
	output	     uart_empty;
	input [7:0]	     uart_data_in;
	output [7:0]	     uart_data_out;	
	
	output uart_baud_clock;
	
	input	     clock;
	input	     reset;
	
	wire uart_internal_clock;
	wire uart_x4_internal_clock;
	assign uart_baud_clock = uart_internal_clock;
	/*
	57600 * 4 = 230400
	50x10^6/230400 = 217 or 7 * 31
	
	div0 = 7 - 2
	div1 = 31
	
	// 9600
	parameter	div0		=	8'd4, //4,
	div1		=	8'd217; // 217;
	*/
	
	// Set the UART clock divisor for 56kbaud
	// 57600
	parameter 		div0	=	8'd5,
		div1	=	8'd31;
	//
	// Baud rate generator
	//
	sasc_brg uart_baud_rate_generator(
		.clk( clock ),
		.rst( reset ),
		.div0( div0 ),
		.div1( div1 ),
		.sio_ce( uart_internal_clock ),
		.sio_ce_x4( uart_x4_internal_clock )
		);
	
	sasc_top uart_sasc_top(
		.clk( clock ),
		.rst( reset ),
		
		// extrnal interfaces
		.rxd_i( io_recv ),
		.txd_o( io_send ),
		
		// Clear to Send, 0 
		.cts_i( 1'b0 ),  // '
		// Ready to send, not hooked up externally       
		.rts_o( uart_sasc_top_rts ),
		
		// brg hookups
		.sio_ce( uart_internal_clock ),
		.sio_ce_x4( uart_x4_internal_clock ),
		
		.din_i( uart_data_in ),
		.dout_o( uart_data_out ),
		.re_i( uart_read_enable_i ),
		.we_i( uart_write_enable_i ),
		.full_o( uart_full ),
		.empty_o( uart_empty )
		);
	
	
endmodule

