module invert(
	clock, 	 
	reset,
	recv,
	send,
	baud_clock
	);
	
	input clock;
	input reset;
	input recv;
	output send;
	output baud_clock;
	
	wire	uart_read_enable_i;
	wire	uart_write_enable_i;
	wire	uart_full;
	wire	uart_empty;
	reg [7:0]	uart_data_in;
	wire	[7:0] uart_data_out;
	reg [7:0]    inverted_data;
	reg          inverted_data_ready;  
	wire baud_clock;
	
	UART myUart(
		recv,
		send,
		
		uart_read_enable_i,
		uart_write_enable_i,
		uart_full,
		uart_empty,
		uart_data_in,
		uart_data_out,
		
		baud_clock,
		
		clock,
		reset
		);
	
	always @(posedge clock)
	
			begin
			end
	
	assign	uart_read_enable_i = !uart_empty;
	assign  uart_write_enable_i = inverted_data_ready;
	
	always @(posedge clock)
	begin
		if( reset )
			begin
				inverted_data_ready = 0; 
				inverted_data = 8'h00;
			end
		else
		if( !uart_empty ) 
			begin
				// inverted_data should get the inverted value before
				// inverted_data_Ready goes high.
				inverted_data = 8'hff - uart_data_out;
				inverted_data_ready = 1;			   
			end
		else if( inverted_data_ready )
			begin	
				inverted_data_ready = 0;
				uart_data_in = inverted_data; 
			end
		
		else 
			begin
			end
	end
	

	
	
	
endmodule
